class ObjectContainer {
 
  ArrayList      _container;
  
  int            _gridAxisSize;
  int            _gridSize;
  ArrayList      _defaultOptions;
  
  int            _interactionMode;
  int            _interactionModeOld;
  
  int            _pulseDistance;
  float          _pulseState;
  
  
  
  ObjectContainer(int gridAxisSize, int gridSize, ArrayList options) {
    
      this._gridAxisSize = gridAxisSize;
      this._gridSize = gridSize;
      this._defaultOptions = options;
      
      this._container = new ArrayList();
      
      this._interactionMode = (Integer)options.get(3);
      
      this._pulseDistance = 0;
      this._pulseState = 0;

  }

  ObjectContainer(int gridAxisSize, int gridSize, int type, float state, ArrayList options) {

    this._gridAxisSize = gridAxisSize;
    this._gridSize = gridSize;
    this._defaultOptions = options;
    
    this._container = new ArrayList();
    
    
    for(int cycle = 1; cycle <= _gridSize; cycle++) {    
    
      this.add(type, state, this._defaultOptions);
    
    }
    
    this._interactionMode = (Integer)options.get(3);
    
    this._pulseDistance = 0;
    this._pulseState = 0;
    
  }
  
  void add(int type, float state, ArrayList options) {
  
    _container.add(_container.size(), new Objects(type, state, options));
  
  }
  
  
  
  boolean draw() {
    
    if(_container.size() >= this._gridSize) {
      
      for(int cycle = 0; cycle < this._gridSize; cycle++) {
  
        Objects currentObject = (Objects)_container.get(cycle);
        
        float distance = dist(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize), hand1Pos.x, hand1Pos.y);
        
        if(distance <= workspace.y * sqrt(2)) distance = map(distance, 0, workspace.y * sqrt(2), 0, 10);
        else distance = 10;
        
        PVector objectPos;
        PVector mousePos;
        
        float distanceX;
        float distanceY;
        
        pushMatrix();
          
          switch(this._interactionMode) {
          
            case 0:
            
              translate(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize), 0);
            
            break;
            case 1:
                        
              objectPos = new PVector(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize), 0);
              mousePos = new PVector(hand1Pos.x, hand1Pos.y, 0);
              
              distanceX = map(mousePos.x - objectPos.x, -300 * 2, 300 * 2, PI / 2, -PI / 2);
              distanceY = map(mousePos.y - objectPos.y, -300 * 2, 300 * 2, -PI / 2, PI / 2);

              if(distance <= _gridAxisSize / 8) {
              
                translate(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize), (PI / 2) * 280 - sqrt(sq(distanceX) + sq(distanceY)) * 500);
                
                //float distAngle = PVector.angleBetween(objectPos, mousePos);
                
                float distAngle = atan2(mousePos.y - objectPos.y , mousePos.x - objectPos.x);
                
                rotateY(distanceX);
                rotateX(distanceY);
              
              } else {
                
                translate(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize));
                
              }
                          
            break;
            case 2:
            
              objectPos = new PVector(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize), 0);
              mousePos = new PVector(hand1Pos.x, hand1Pos.y, 0);
              
              distanceX = map(mousePos.x - objectPos.x, -300 * 2, 300 * 2, -PI / 2, PI / 2);
              distanceY = map(mousePos.y - objectPos.y, -300 * 2, 300 * 2, PI / 2, -PI / 2);

              if(distance <= _gridAxisSize / 8) {
              
                translate(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize), -((PI / 2) * 280 - sqrt(sq(distanceX) + sq(distanceY)) * 500));
                
                //float distAngle = PVector.angleBetween(objectPos, mousePos);
                
                float distAngle = atan2(mousePos.y - objectPos.y , mousePos.x - objectPos.x);
                
                rotateY(distanceX);
                rotateX(distanceY);
              
              } else {
                
                translate(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize));
                
              }
            
            break;
            case 3:

                objectPos = new PVector(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize), 0);
                mousePos = new PVector(hand1Pos.x, hand1Pos.y, 0);
            
                translate(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize));
            
                float distAngle = atan2(mousePos.y - objectPos.y , mousePos.x - objectPos.x);
            
                scale(distance / 10);
                
                rotate(distAngle);
            
            break;
            case 4:
                        
              //println(this._pulseDistance + "---" + round(distance));
                        
              if(round(distance * 2.5) == this._pulseDistance) {
        
                translate(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize), (0.5 + 0.5 * this._pulseState) * 100);
                
                scale(0.5 + 0.5 * this._pulseState);
                        
              } else if(round(distance * 2.5) == this._pulseDistance + 1) {
               
                translate(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize), (1 - 0.5 * this._pulseState) * 100);
                
                scale(1 - 0.5 * this._pulseState);
                      
              } else {
                        
                translate(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize));
                
                scale(0.5);
                
              }

            break;
            case 5:
            
              translate(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize), -distance * 10);
              
              rotate(radians(distance * 36));

            break;
            case 6:

              translate(workspace.x / _gridAxisSize * (cycle % _gridAxisSize), workspace.x / _gridAxisSize * ceil(cycle / _gridAxisSize), -distance * 5);
              
              //rotate(radians(distance * 36));
              
              scale((distance % 2) * 2);
      
            break;
            case 7:
      
            break;
            case 8:
      
            break;
            case 9:
      
            break;      
          
          }
          
          currentObject.draw();
        
        popMatrix();
      
      }
     
      this._pulseState += 0.2;
      
      if(this._pulseState >= 1) {
        
        this._pulseState = 0;
        
        this._pulseDistance = (this._pulseDistance) % (_gridAxisSize) + 1;
        
      }
     
     return true;
      
    } else {
     
     return false;
      
    }
    
  }


  int getInteractionMode() {
    
    return this._interactionMode;
    
  }  
  
  void setInteractionMode(int interactionMode) {
    
    this._interactionMode = interactionMode;
    
  }
  
  
  void morph(int objectId, int type, float state) {
    
    Objects currentObject = (Objects)_container.get(objectId);
    
    currentObject.setType(type);
    
    currentObject.setState(state);
    
    _container.set(objectId, currentObject);
    
  }
  
  
  void morphAll(int type, float state) {
    
    for(int cycle = 0; cycle < this._gridSize; cycle++) {    
      
      Objects currentObject = (Objects)_container.get(cycle);
      
      currentObject.setType(type);
      
      currentObject.setState(state);
      
      _container.set(cycle, currentObject);
      
    }
    
  }
  
}
